'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Sends simple email using mailing microservice
 */
module.exports = exports = function definedSubjectAndSend(props, wait = false) {
  const { email, type, context, emailTemplate, nodemailer = {} } = props;
  const { config, mailer } = this;
  const { validation } = config;
  const { subjects, senders, email: mailingAccount } = validation;

  const mail = (0, _extends3.default)({}, nodemailer, {
    subject: subjects[type] || '',
    from: senders[type] || 'noreply <support@example.com>',
    to: email,
    html: emailTemplate
  });

  const mailSent = mailer.send(mailingAccount, mail).return({ sent: true, context }).catch(err => ({
    context,
    err,
    sent: false
  }));

  if (wait) {
    return mailSent;
  }

  return {
    queued: true,
    context
  };
};